#include <allegro.h>
#include <alleggl.h>
#include <math.h>

#include "util.h"
#include "collision.h"



COLLISION_RESULT check_collision(COLLISION_DATA *c1, COLLISION_DATA *c2) {

    COLLISION_RESULT res;
    float dx, dy, d, r;

    dx = c1->x - c2->x;
    dy = c1->y - c2->y;

    res.vertical = (c1->y < c2->y) ? UP : DOWN;
    res.horizontal = (c1->x < c2->x) ? RIGHT : LEFT;

    d = dx * dx + dy * dy;
    r = c1->r * c1->r + c2->r * c2->r;

    res.collision = d <= r;
    res.d = r - d;

    return res;
}
