#include <allegro.h>
#include <alleggl.h>

#include "parody.h"
#include "message.h"



#define MAX_MESSAGE_TIME  30



typedef struct MESSAGE MESSAGE;



struct MESSAGE {
    char *text;
    float x, y;
    int timer;
    int showing;
};



static FONT *msg_font;
static MESSAGE msg;



int init_messages(DATAFILE *data) {
    allegro_gl_set_texture_format(GL_ALPHA8);
    msg_font = allegro_gl_convert_allegro_font((FONT *) data[DAT_FONT_SMALL].dat,
	                                              AGL_FONT_TYPE_TEXTURED, 110.0);
    if (!msg_font) {
        return 0;
    }
    return 1;
}



void set_message(float x, float y, char *message) {
    msg.text = message;
    msg.x = x;
    msg.y = y;
    msg.timer = MAX_MESSAGE_TIME;
    msg.showing = 1;
}



void update_message() {
    if (msg.timer > 0) {
        --msg.timer;
    } else {
        msg.timer = MAX_MESSAGE_TIME;
        msg.showing = 0;
    }
}



void draw_message() {
    if (msg.showing) {
        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

        glEnable(GL_TEXTURE_2D);
        glEnable(GL_BLEND);

        allegro_gl_printf(msg_font, msg.x, msg.y, 0, makecol(255,255,255), msg.text);

        glDisable(GL_BLEND);
        glColor4f(1.0, 1.0, 1.0, 1.0);
    }
}



void end_messages() {
    allegro_gl_destroy_font(msg_font);
}
